//
//  Winmail.h
//  TNEFsEnough
//
//  Created by Josh Jacob on 5/27/11.
//  Copyright 2011 Josh Jacob. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import <WebKit/WebKit.h>

@class LibytnefHelper;
@class FileTableViewDataSource;

@interface Winmail : NSDocument <NSTableViewDelegate, NSStreamDelegate> {
@private
    
    LibytnefHelper * tnefHelper;
    
    // table view data source
    FileTableViewDataSource * fileDataSource;
    
    // view outlets
    NSTextField *__unsafe_unretained fieldFrom;
    NSTextField *__unsafe_unretained fieldSubject;
    NSTextField *__unsafe_unretained fieldDate;
    NSTableView *__unsafe_unretained tableFiles;
    NSTextView *__unsafe_unretained fieldBody;
    NSScrollView *__unsafe_unretained fieldBodyScrollView;
    WebView *__unsafe_unretained webview;
    NSBox *__unsafe_unretained webViewBox;
    
    // print view outlets
    NSView *__unsafe_unretained printView;
    NSTextField *__unsafe_unretained printFieldFrom;
    NSTextField *__unsafe_unretained printFieldSubject;
    NSTextField *__unsafe_unretained printFieldDate;
    NSTextView *__unsafe_unretained printFieldBody;
    WebView *__unsafe_unretained printWebview;
    
    // export
    BOOL exportOne;
    NSURL * exportFile;
    NSURL * exportDir;
    NSMutableArray *exportArray;
    NSOutputStream *outputStream;
    
    // sheet
    // NSWindow *__weak savingSheet;
    NSWindow *__unsafe_unretained savingSheet;
    NSTextField *__unsafe_unretained savingSheetLabel;
    NSProgressIndicator *__unsafe_unretained savingSheetProgress;
}

@property (nonatomic, strong) LibytnefHelper * tnefHelper;

@property (nonatomic, strong) IBOutlet FileTableViewDataSource * fileDataSource;

@property (unsafe_unretained) IBOutlet NSTextField *fieldFrom;
@property (unsafe_unretained) IBOutlet NSTextField *fieldSubject;
@property (unsafe_unretained) IBOutlet NSTextField *fieldDate;
@property (unsafe_unretained) IBOutlet NSTableView *tableFiles;
@property (unsafe_unretained) IBOutlet NSTextView *fieldBody;
@property (unsafe_unretained) IBOutlet NSScrollView *fieldBodyScrollView;
@property (unsafe_unretained) IBOutlet WebView *webview;
@property (unsafe_unretained) IBOutlet NSBox *webViewBox;

@property (unsafe_unretained) IBOutlet NSView *printView;
@property (unsafe_unretained) IBOutlet NSTextField *printFieldFrom;
@property (unsafe_unretained) IBOutlet NSTextField *printFieldSubject;
@property (unsafe_unretained) IBOutlet NSTextField *printFieldDate;
@property (unsafe_unretained) IBOutlet NSTextView *printFieldBody;
@property (unsafe_unretained) IBOutlet WebView *printWebview;

@property (nonatomic, strong) NSURL * exportFile;
@property (nonatomic, strong) NSURL * exportDir;
@property (nonatomic, strong) NSMutableArray *exportArray;
@property (nonatomic, strong) NSOutputStream *outputStream;
// @property (weak) IBOutlet NSWindow *savingSheet;
@property (unsafe_unretained) IBOutlet NSWindow *savingSheet;
@property (unsafe_unretained) IBOutlet NSTextField *savingSheetLabel;
@property (unsafe_unretained) IBOutlet NSProgressIndicator *savingSheetProgress;

- (IBAction) exportSelectedAttachment: (id) sender;
- (void) kickOffExport;
- (IBAction) exportAll: (id) sender;
- (void) exportSet: (NSArray *) rows;
- (void) kickOffExportAll;
- (void) kickOffExportAllNext;
- (void) doubleClickTable: (id) sender;

@end
